#!/usr/bin/awk -f
BEGIN {
  print "/* Automatically generated from chars.dat. Do not edit. */"
  print "#ifndef CHARS_H"
  print "#define CHARS_H"
}
{
  gsub(/#.*/,"")
  gsub(/[ 	]*$/,"")
  if ($0 == "") next
  name = gensub(/[ 	].*$/,"",1)
  body = gensub(/^[^ 	]*[ 	]*/,"",1)
  if (name == "" || body == "") {
    printf "chars.awk: syntax error in chars.dat line %s\n",NR > "/dev/stderr"
    exit 1
  }
  printf "\n\
#ifdef C%s\n\
# define MYC%s C%s\n\
#else\n\
# define MYC%s %s\n\
#endif\n",name,name,name,name,body
}
END {
  print "#endif /* CHARS_H */"
}
